## gate.creole
Class AbstractVisualResource

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JPanel
                              |
                              +--gate.creole.AbstractVisualResource

All Implemented Interfaces:
  Accessible, FeatureBearer, ImageObserver, MenuContainer, NameBearer, Resource, Serializable, VisualResource

Direct Known Subclasses:
  AnnotationDiff, ApplicationEditor, CorpusEditor, DocumentEditor, FeaturesEditor, SchemaAnnotationEditor, SerialControllerEditor, SyntaxTreeViewer, UnrestrictedAnnotationEditor

public abstract class AbstractVisualResource
extends JPanel
implements VisualResource

A convenience implementation of VisualResource with some default code.

See Also:
  Serialized Form

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Fields inherited from class javax.swing.JComponent
`TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`AbstractVisualResource()` Package access constructor to stop normal initialisation.

Method Summary
`void` `cleanup()` Does nothing now, but meant to clear all internal data
`FeatureMap` `getFeatures()` Accessor for features.
`Object` `getParameterValue(String paramaterName)` Gets the value of a parameter of this resource.
`Resource` `init()` Initialise this resource, and return it.
`void` `setFeatures(FeatureMap features)` Mutator for features
`void` `setHandle(Handle handle)` Used by the main GUI to tell this VR what handle created it.
`void` `setParameterValue(String paramaterName, Object parameterValue)` Sets the value for a specified parameter.
`void` `setParameterValues(FeatureMap parameters)` Sets the values for more parameters in one step.
`void` `setTarget(Object target)` Called by the GUI when this viewer/editor has to initialise itself for a specific object.

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUIClassID, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVerifyInputWhenFocusTarget, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, hide, isDoubleBuffered, isFocusCycleRoot, isFocusTraversable, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setLayout, validate`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, dispatchEvent, enable, enableInputMethods, getBackground, getBounds, getColorModel, getComponentOrientation, getCursor, getDropTarget, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getInputContext, getInputMethodRequests, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, imageUpdate, inside, isDisplayable, isEnabled, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface gate.util.NameBearer
`getName, setName`

Constructor Detail

### AbstractVisualResource

    public AbstractVisualResource()

  Package access constructor to stop normal initialisation. This kind of resources should only be created by the Factory class

Method Detail

### getFeatures

    public FeatureMap getFeatures()

  Accessor for features.
  Specified by:
    `getFeatures` in interface `FeatureBearer`

### setFeatures

    public void setFeatures(FeatureMap features)

  Mutator for features
  Specified by:
    `setFeatures` in interface `FeatureBearer`

### init

    public Resource init()
                  throws ResourceInstantiationException

  Initialise this resource, and return it.
  Specified by:
    `init` in interface `Resource`

### cleanup

    public void cleanup()

  Does nothing now, but meant to clear all internal data
  Specified by:
    `cleanup` in interface `Resource`

### setTarget

    public void setTarget(Object target)

  Called by the GUI when this viewer/editor has to initialise itself for a specific object.
  Specified by:
    `setTarget` in interface `VisualResource`
  Parameters:
    `target` - the object (be it a `Resource`, `DataStore` or whatever) this viewer has to display

### setHandle

    public void setHandle(Handle handle)

  Used by the main GUI to tell this VR what handle created it. The VRs can use this information e.g. to add items to the popup for the resource.
  Specified by:
    `setHandle` in interface `VisualResource`

### getParameterValue

    public Object getParameterValue(String paramaterName)
                             throws ResourceInstantiationException

  Gets the value of a parameter of this resource.
  Specified by:
    `getParameterValue` in interface `Resource`
  Parameters:
    `paramaterName` - the name of the parameter
  Returns:
    the current value of the parameter

### setParameterValue

    public void setParameterValue(String paramaterName,
                                  Object parameterValue)
                           throws ResourceInstantiationException

  Sets the value for a specified parameter.
  Specified by:
    `setParameterValue` in interface `Resource`
  Parameters:
    `paramaterName` - the name for the parameteer
    `parameterValue` - the value the parameter will receive

### setParameterValues

    public void setParameterValues(FeatureMap parameters)
                            throws ResourceInstantiationException

  Sets the values for more parameters in one step.
  Specified by:
    `setParameterValues` in interface `Resource`
  Parameters:
    `parameters` - a feature map that has paramete names as keys and parameter values as values.